"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var core_2 = require("@ng2-dynamic-forms/core");
exports.DYNAMIC_FORM_UI_BOOTSTRAP = "BOOTSTRAP";
var DynamicFormBootstrapComponent = (function (_super) {
    __extends(DynamicFormBootstrapComponent, _super);
    function DynamicFormBootstrapComponent() {
        _super.call(this);
        this.type = exports.DYNAMIC_FORM_UI_BOOTSTRAP;
    }
    __decorate([
        core_1.Input(), 
        __metadata('design:type', forms_1.FormGroup)
    ], DynamicFormBootstrapComponent.prototype, "controlGroup", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', core_2.DynamicFormControlModel)
    ], DynamicFormBootstrapComponent.prototype, "model", void 0);
    __decorate([
        core_1.ContentChild(core_1.TemplateRef), 
        __metadata('design:type', Object)
    ], DynamicFormBootstrapComponent.prototype, "customTemplate", void 0);
    DynamicFormBootstrapComponent = __decorate([
        core_1.Component({
            directives: [forms_1.REACTIVE_FORM_DIRECTIVES, core_1.forwardRef(function () { return DynamicFormBootstrapComponent; })],
            moduleId: module.id,
            selector: "dynamic-form-bootstrap-control",
            template: "<div class=\"form-group\" [formGroup]=\"controlGroup\" [ngClass]=\"[model.cls.element.container, model.cls.grid.container]\" [ngSwitch]=\"model.type\"><label *ngIf=\"!isCheckbox && model.label\" [attr.for]=\"model.id\" [ngClass]=\"[model.cls.element.label, model.cls.grid.label]\">{{model.label}}</label><div *ngSwitchCase=\"'CHECKBOX'\" [ngClass]=\"model.cls.grid.control\"><div class=\"checkbox\" [class.disabled]=\"model.disabled\"><label [attr.for]=\"model.id\" [ngClass]=\"model.cls.element.label\"><input type=\"checkbox\" [disabled]=\"model.disabled\" [formControlName]=\"model.id\" [name]=\"model.name\" [required]=\"model.required\" [value]=\"model.value\" [ngClass]=\"model.cls.element.control\" [(ngModel)]=\"model.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\">{{model.label}}</label></div></div><div *ngIf=\"!isCheckbox\" [ngClass]=\"model.cls.grid.control\"><div *ngSwitchCase=\"'ARRAY'\" [formArrayName]=\"model.id\" [ngClass]=\"model.cls.element.control\"><fieldset *ngFor=\"let idx = index; let group of model.groups\" [formGroupName]=\"idx\"><dynamic-form-bootstrap-control *ngFor=\"let controlModel of group\" [controlGroup]=\"controlGroup.controls[model.id].controls[idx]\" [model]=\"controlModel\"></dynamic-form-bootstrap-control><template [ngTemplateOutlet]=\"customTemplate\"></template></fieldset></div><fieldset *ngSwitchCase=\"'GROUP'\" [disabled]=\"model.disabled\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><dynamic-form-bootstrap-control *ngFor=\"let controlModel of model.group\" [controlGroup]=\"controlGroup.controls[model.id]\" [model]=\"controlModel\"></dynamic-form-bootstrap-control></fieldset><fieldset *ngSwitchCase=\"'CHECKBOX_GROUP'\" [disabled]=\"model.disabled\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"model.cls.element.control\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><div *ngFor=\"let item of model.group\" class=\"checkbox\" [class.disabled]=\"item.disabled\"><label [attr.for]=\"item.id\" [ngClass]=\"item.cls.element.label\"><input type=\"checkbox\" [disabled]=\"item.disabled\" [formControlName]=\"item.id\" [name]=\"item.name\" [required]=\"model.required\" [value]=\"item.value\" [ngClass]=\"item.cls.element.control\" [(ngModel)]=\"item.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\">{{model.label}}</label></div></fieldset><div *ngSwitchCase=\"'INPUT'\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\">{{model.prefix}}</div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.autoComplete]=\"model.autoComplete\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.maxlength]=\"model.maxLength\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [autofocus]=\"model.autoFocus\" [disabled]=\"model.disabled\" [formControlName]=\"model.id\" [name]=\"model.name\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [type]=\"model.inputType\" [ngClass]=\"model.cls.element.control\" [(ngModel)]=\"model.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\">{{model.suffix}}</div><datalist *ngIf=\"model.list\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div><fieldset *ngSwitchCase=\"'RADIO_GROUP'\" role=\"radiogroup\" [disabled]=\"model.disabled\" [name]=\"model.name\"><legend *ngIf=\"model.legend\">{{model.legend}}</legend><div *ngFor=\"let option of model.options\" class=\"radio\" [class.disabled]=\"option.disabled\"><label><input type=\"radio\" [disabled]=\"!!option.disabled\" [formControlName]=\"model.id\" [name]=\"model.name\" [value]=\"option.value\" [ngClass]=\"model.cls.element.control\" [(ngModel)]=\"model.value\">{{option.label}}</label></div></fieldset><select *ngSwitchCase=\"'SELECT'\" class=\"form-control\" [disabled]=\"model.disabled\" [formControlName]=\"model.id\" [name]=\"model.name\" [required]=\"model.required\" [ngClass]=\"model.cls.element.control\" [(ngModel)]=\"model.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\"><option *ngFor=\"let option of model.options\" [disabled]=\"!!option.disabled\" [attr.name]=\"model.name\" [ngValue]=\"option.value\">{{option.label}}</option></select><textarea *ngSwitchCase=\"'TEXTAREA'\" class=\"form-control\" [attr.maxlength]=\"model.maxLength\" [cols]=\"model.cols\" [disabled]=\"model.disabled\" [formControlName]=\"model.id\" [name]=\"model.name\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [wrap]=\"model.wrap\" [ngClass]=\"model.cls.element.control\" [(ngModel)]=\"model.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\"></textarea><span *ngIf=\"model.help\" class=\"help-block\">{{model.help}}</span></div><ng-content></ng-content></div>"
        }), 
        __metadata('design:paramtypes', [])
    ], DynamicFormBootstrapComponent);
    return DynamicFormBootstrapComponent;
}(core_2.DynamicFormControlComponent));
exports.DynamicFormBootstrapComponent = DynamicFormBootstrapComponent;
//# sourceMappingURL=dynamic-form-bootstrap.component.js.map